/*
$Id: dns.h,v 1.3 2005/08/10 10:13:02 alex Exp $
	dns.h--- for EDB DNS
*/

#ifndef	DNS_Inc_Defined
#define	DNS_Inc_Defined

#define	NS_REFRESH	3600
#define	NS_RETRY	900
#define	NS_EXPIRE	3600000
#define	NS_MINIMUM	86400


#define	DNS_NS_LIMIT	40
#define	DNS_MX_LIMIT	40

struct	DNS_DOMAIN_INFO {
	char	domain[NS_MAXDNAME];
	char	server[NS_MAXDNAME];
	struct	{
		char	mname[NS_MAXDNAME];
		char	rname[NS_MAXDNAME];
		long int	serial;
		long int	refresh;
		long int	retry;
		long int	expire;
		long int	minimum;
	} soa;
	int	ns_num;
	char	ns[DNS_NS_LIMIT][NS_MAXDNAME];
};

#define	DNS_NOT_AUTHORITATIVE	(-1)

		int	dns_initialize					__P((void));
		int	dns_store_default				__P((void));
		int	dns_restore_default				__P((void));
		int	dns_find_NS					__P((char *, char *[], char *[], int *, FILE *));
		int	dns_query_domain_information		__P((char *, char *nameserver, struct DNS_DOMAIN_INFO *, FILE *));
		int	dns_compare_domain_information	__P((struct DNS_DOMAIN_INFO *, struct DNS_DOMAIN_INFO *));

#endif	/* DNS_Inc_Defined */


