#!/bin/sh
#
# $Id: edb-dns-conf.sh,v 1.1 2004/11/11 12:13:28 alex Exp alex $
#

myname=$1
if [ X$myname = "X" ]; then
	echo 'usage:' $0 '<fqdn.of.name.server>'
	exit 0
fi

if [ "X$DNSDIR" = "X" ]; then
	DNSDIR=/etc/ns
fi
if [ "X$DNSGET" = "X" ]; then
	DNSGET='/usr/local/bin/wget -q -O -'
fi
EDBBIND=$DNSGET' http://150.59.230.68/DNS/BIND'

getzone() {

zone=$1
$EDBBIND/ZONE/$zone > response
grep '^; END-OF-' response > eoi
if [ -s eoi ]; then
	mv response $zone.zone
else
	rm -f response
fi
rm -f eoi
}

getrev() {

cidr=$1
mask=`echo $cidr | awk -F/ '{print $2}'`
rev=`echo $cidr | awk -F/ '{
  split($1,a,".");
  if($2==16) {
    printf("%s.%s",a[1],a[2]);
  } else {
    printf("%s.%s.%s",a[1],a[2],a[3]);
  }
}'`
$EDBBIND/REV/$cidr > response
grep '^; END-OF-' response > eoi
if [ -s eoi ]; then
	mv response $rev.rev
else
	rm -f response
fi
rm -f eoi
}

if [ -f $DNSDIR/named.conf-options ]; then
	cp $DNSDIR/named.conf-options nsconf.dat
else
	rm -f nsconf.dat
	touch nsconf.dat
fi

$EDBBIND/CONF/$myname >> nsconf.dat
grep '^; END-OF-' nsconf.dat > eoi
if [ -s eoi ]; then
	echo > /dev/null
else
	echo "ERROR: cannot get nameserver configuration."
	exit 1
fi
rm -f eoi

rm -f named.conf-body
# nsconf.dat format:
# nstype/ZONE/domain/master
# nstype/REV/network/mask/master
cat nsconf.dat | grep -v '^;' | awk -F/ '
BEGIN {
  printf("acl tunes-network {\n");
  printf("\t150.59.0.0/16;\n");
  printf("};\n\n");
}
{
  if($1=="OPTION") {
    if(option[$2]) {
      option[$2] = option[$2] "\n\t" $3;
    } else {
      option[$2] = $3;
    }
  } else if($1=="PRIMARY") {
    if($2=="ZONE") {
      zn = $3;
      bn = "zone/" $3 ".zone";
    } else if($2=="REV") {
      split($3, nn, ".");
      if($4==16) {
        zn = nn[2] "." nn[1] ".in-addr.arpa";
        bn = "rev/" nn[1] "." nn[2] ".rev";
      } else {
        zn = nn[3] "." nn[2] "." nn[1] ".in-addr.arpa";
        bn = "rev/" nn[1] "." nn[2] "." nn[3] ".rev";
      }
    }
    printf("zone \"%s\" {\n", zn);
    printf("\ttype master;\n");
    printf("\tfile \"%s\";\n", bn);
    if(option[zn]) printf("\t%s\n", option[zn]);
    printf("\tallow-query { any; };\n");
    printf("\tallow-transfer { tunes-network; };\n");
    printf("};\n\n");
  } else if($1=="SECONDARY") {
    if($2=="ZONE") {
      zn = $3;
      bn = "back/" $3 ".zone";
      master = "{ " $4 "; };";
    } else if($2=="REV") {
      split($3, nn, ".");
      if($4==16) {
        zn = nn[2] "." nn[1] ".in-addr.arpa";
        bn = "back/" nn[1] "." nn[2] ".rev";
      } else {
        zn = nn[3] "." nn[2] "." nn[1] ".in-addr.arpa";
        bn = "back/" nn[1] "." nn[2] "." nn[3] ".rev";
      }  
      master = "{" $5 "; };";
    }
    printf("zone \"%s\" {\n", zn);
    printf("\ttype slave;\n");
    printf("\tfile \"%s\";\n", bn);
    printf("\tmasters %s\n", master);
    if(option[zn]) printf("\t%s\n", option[zn]);
    printf("\tallow-query { any; };\n");
    printf("\tallow-transfer { tunes-network; };\n");
    printf("};\n\n");
  }
}' > named.conf-body

for zone in `cat nsconf.dat | awk -F/ '{
  if($1=="PRIMARY" && $2=="ZONE") printf("%s\n", $3);
}'`
do
  getzone $zone
done

for rev in `cat nsconf.dat | awk -F/ '{
  if($1=="PRIMARY" && $2=="REV") printf("%s/%s\n", $3, $4);
}'`
do
  getrev $rev
done

exit 0

